
 
    
;****************************************************************************************
;*                                                                                      * 
;*         TEMPERATUR-MESSUNG MIT LM75 UND I2C- UND SPI-SCHNITTSTELLE                   *
;*         ==========================================================                   *
;*                                                                                      *
;*                                   31.08.23                                           *
;*                                                                                      *    
;****************************************************************************************


    LIST    P=PIC12F1840
 
    ;TITLE   "TEMPERATUR"

    ERRORLEVEL -302
    INCLUDE <P12F1840.INC>

;--------------------------------------------------------------------------

;ALS OSZILLATOR INTERN 32MHZ  (T=0.03125S T:=TAKTZEIT)

;---------------------------------------------------------------------------------
 
 __CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_OFF & _PWRTE_OFF & _MCLRE_OFF & _CP_OFF & _BOREN_ON & _IESO_OFF & 0X3FFF
 __CONFIG _CONFIG2, _WRT_OFF & _PLLEN_ON & _BORV_HI & _LVP_OFF & 0X3FFF
           
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
 

;---------------------------------------------------------------------------------
;ADRESSE /// BRUECKEN MUESSEN DEM ENTSPRECHEND SEIN AUF DEM SENSOR LM75
;FUER I2C        
LM75_ADRESSE    EQU 0X90 
;---------------------------------------------------------------------------------
;FUER WIEVIEL MESSUNGEN ERFOLGT LAUFSCHRIFT
NACH_WIEVIEL    EQU D'120'  ;DA EINE MESSUNG 0,5SEC DAUERT SIND DIES 60SEC BIS EINE LAUFSCHRIFT ERNEUT WIEDERHOLEND ERFOLGT
;NACH_WIEVIEL    EQU D'0'    ;BEI NULL ERFOLGT KEINE LAUFTSCHRIFT ZWISCHEN DURCH --NUR AM ANFANG BEIM EINSCHALTEN ERFOLGT DIE LAUFSCHRIFT    
;---------------------------------------------------------------------------------
;FUER MESS-MERKER-PUNKT AUFBLITZEN
BLITZ           EQU D'0'    ; OHNE AUFBLITZEN DES PUNKTES BEI EINER MESSUNG
;BLITZ           EQU D'1'    ; MIT AUFBLITZEN DES PUNKTES BEI EINER MESSUNG
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
;FUER LAUFSCHRIFT 1X8 DISPLAY 
ANZAHL          EQU D'8'    ; DISPLAY ZEICHEN ANZAHL
L_ADRESSE       EQU H'87'   ; LETZTE ADRESSE AUF DISPLAY
GESCHWINDIGKEIT EQU D'35'   ; 350MSEC BIS NAECHSTES ZEICHEN KOMMT
DURCHLAEUFE     EQU D'1'    ; 1 DURCHLAEUFE 
;---------------------------------------------------------------------------------
;FUER GRAD-ANZEIGE     
LCD_ADR_GRAD    EQU 0X80    ; EINS VOR DER LINKESTEN LCD-ADRESSE // DANACH STEHT DAS MINUS ZEICHEN 0DER DIE HUNDERTER STELLE IN C
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
;PINS FUER DEN PIC12F1840 KURZ-SCHREIBWEISE / ZUORDNUNG
;FUER SPI        
SDO        EQU 0   ;RA0 AUSGANG / FUER SPI LCD
SCK        EQU 1   ;RA1 AUSGANG / FUER SPI LCD // DOPPELT BELEGT MIT AUCH I2C //
CS         EQU 5   ;RA5 AUSGANG / FUER SPI LCD       
RS         EQU 4   ;RA4 AUSGANG / FUER LCD  OB BEFEHL ODER DATEN
    
;FUER I2C   
SCL        EQU 1   ;RA1 EINGANG / FUER I2C // DOPPELT BELEGT MIT AUCH SPI // SIND BEIDES AUSGAENGE - MUESSEN ABER BEIM INIT ENABLE INIT EINGAENGE SEIN !!!!
SDA        EQU 2   ;RA2 EINGANG / FUER I2C                                 - SCHALTET SELBST AUF AUSGAENGE UM
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
;VARIABLEN
BIT0        EQU 0
BIT1        EQU 1
BIT2        EQU 2
BIT3        EQU 3
BIT4        EQU 4
BIT5        EQU 5
BIT6        EQU 6
BIT7        EQU 7
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 21 HEX LOS
;ALSO DIE RAM-SPEICHER ZUORDNUNG
 
;FUER ZEITSCHLEIFEN         
HELP1       EQU 0X21
HELP2       EQU 0X22
HELP3       EQU 0X23
       
;HILFS-VARIABLE
ZAEHL       EQU 0X24
        
;FUER DATEN-AUSGABE AUF DOGM DISPLAY        
DAT         EQU 0X25            

;FUER LM75 AUSGELESENE DATEN (TEMPERATUR-HEX) UND (TEMPERATUR DEZ ANZEIGEN)  
TEMP_L      EQU 0X26
TEMP_H      EQU 0X27

;FUER TEMPERATUR ANZEIGEN  
MERK2       EQU 0X28
TEM         EQU 0X29
ANZ_L       EQU 0X2A
ANZ_H       EQU 0X2B   
MINUS       EQU 0X2C
ZAE         EQU 0X2D
VER         EQU 0X2E
     
ZAEHLER     EQU 0X2F     
 
;FUER LAUFSCHRIFT
TXT         EQU 0X30
ZAE_L       EQU 0X31
LCD_ADR     EQU 0X32
NR          EQU 0X33
NR_HELP     EQU 0X34
ZEILE       EQU 0X35
NEU         EQU 0X36         
MERK_L      EQU 0X37
  
;FUER AUFBLITZEN BEI EINER MESSUNG
BL          EQU 0X38      
;---------------------------------------------------------------------------------   
;---------------------------------------------------------------------------------
;SPEICHERANFANG BZW. BEGINN

    ORG 0X0000
    GOTO    MAIN        ;SPRUNG ZUM HAUPTPROGRAMM
    ORG 0X0004
    RETFIE              ;GOTO INTERRUPT /// JETZT KEIN INTERUPT


    ORG 0X0010                     
;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*****************************************************************************
;PORT-INITIALISIERUNG USW...
MAIN                    MOVLB   D'0'        ;BANK0
                        CLRF    PORTA     
;                        CLRF    PORTB
                        
                        MOVLB   D'2'        ;BANK2
                        CLRF    LATA                    ;ALLES DATA-LATCH
;                        CLRF    LATB
                        
;                        MOVLW   D'2'             ;PIN-ZUORDNUNG FUER SPI UND I2C VERAENDERN  /// HIER NICHT GEMACHT
;                        MOVWF   APFCON0
;                        MOVWF   APFCON1
                        
                        MOVLB   D'1'        ;BANK1
                        MOVLW   B'00001111'             ;RA0_1_2_3 ALS EINGANG (ALSO HIER DIE 1) WEGEN I2C ALS EINGANG // ABER AUCH IM UNTER-PROGRAMM 
                        MOVWF   TRISA
                        
;FR DEN INTERNEN OSZILLATOR 8MHZ /// HOLE ABER EINSTELLUNGEN AUS CONFIG INTERN "OBEN" UND PLL*4 /// DANN 32MHZ
                        MOVLW   B'11110000'             ;JETZT 8MHZ INTERN OHNE PLL*4                
                        MOVWF   OSCCON
                        
;INIT TIMER 0 FUER ZEITSCHLEIFE
                        MOVLW   B'10000111'             ;BIT0-2 000=PRESCALER256, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                        MOVWF   OPTION_REG 

                        MOVLB   D'3'        ;BANK3
                        CLRF    ANSELA                  ;ALLES I/O PINS AM PORTS KEIN ANALOG
                        
                        MOVLB   D'4'        ;BANK4   
                        CLRF    WPUA                    ;ALLES KEIN PULL-UP
                        
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;                        
;SPI INITIALISIERUNG                         
                        CLRF    SSPSTAT                ;IST SCHON ALS GRUNDEINSTELLUNG  ;BIT7=0 (IN DER MITTE AUF DER AUSGABE OUTPUT) // NUR NOCH BIT6 SCHREIBBAR -HAT ALS LOW FUNKTIONIERT
                                                        
                        ;IN UNTERPROGRAMM                                
                        ;MOVLW   B'00010010'            
                                                       ;BIT5=0 SPI-PORTS DISABLE // BIT4=1 FUER HIGH LEVEL MODE-1,1 // AUSGABEFREQUENZ BIT0-3 = 0000 FOSC:4 MAXIMALE AUSGEBE-FREQUENZ GING BEIM DISPLAY NICHT
                                                       ;JETZT KEINE MAX AUSGABE-FREQUENZ FOSZ:64 ALS 0010 -->NUR ZUR SICHERHEIT DIE KLEINSTE AUSGABE-FREQUENZ
                        ;MOVWF   SSP1CON1 
                        
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;                        
;I2C INITIALISIERUNG
                        
                        ;ALS EINGAENGE NUR ZUR SICHERHEIT / EIGENTLICH SCHON OBEN GEMACHT / UND AUCH BEI UNTERPROGRAMM START_I2C WIRD ES GEMACHT
;                        MOVLB   D'1'        ;BANK1
;                        BSF     TRISB, SDA1
;                        BSF     TRISB, SCL1

                        MOVLB   D'4'        ;BANK4
                        MOVLW   D'159'                   ;200KHZ MIT 39 /// 100KHZ MIT 79 ////// 50KHZ MIT 159
                        MOVWF   SSPADD
                        
                        ;IN UNTERPROGRAMM
                        ;MOVLW   B'00001000'            ;BIT5=0 I2C-PORTS DISABLE // BIT4=0 I2C SCL (CLOCK) DISABLE  // BIT0-3 = 1000 MASTERMODE I2C
                        ;MOVWF   SSP1CON1
                                                                        
                        
;---------------------------------------------------------------------------------                        

            MOVLB   D'0'         ;BANK0
            BSF     PORTA, CS    ;CS VON SPI NICHT AKTIV 

            MOVLW   D'50'       ;50MSEC ZEITSCHLEIFE   
            CALL    ZS1MSEC     ;WEGEN KONDENSATOREN AUFLADEN... LCD-MODUL

      
;LCD-MODUL DOGM081 INITIALISIERUNG FUER +5,0VOLT
LCD         MOVLW   D'2'                    ;ZWEI MAL DURCHLAUF
            MOVWF   ZAEHL

;INITIALISIERUNG DOT-MATRIX-LCD
            MOVLW   H'31' ;//H'39'                   ;FUNCTION SET  8-BIT-LAENGE, 1-ZEILIG //2-ZEILIG
            CALL    BEFEHL
 
INIT_LCD    MOVLW   H'14'                    ;1CFALSCH KONTRAST
            CALL    BEFEHL
 
            MOVLW   H'51'                    ;52FALSCH EINS WEITER ADRESSE   POWER CONTROL
            CALL    BEFEHL
 
            MOVLW   H'6A'                    ;FOLLOWER CONTROL
            CALL    BEFEHL
 
            MOVLW   H'74'                    ;CONTRAST SET
            CALL    BEFEHL

            MOVLW   H'30' ;//H'38'                   ;FUNCTION SET  8-BIT-LAENGE, 1-ZEILIG //2-ZEILIG
            CALL    BEFEHL
 
            DECFSZ  ZAEHL, F
            GOTO    INIT_LCD 
            
            MOVLW   H'0C'                   ;DISPLAY ON/OFF   DISPLAY ON, CURSOR OFF, BLINK OFF
            CALL    BEFEHL
            
            MOVLW   D'50'                   ;50MSEC ZEITSCHLEIFE 
            CALL    ZS1MSEC

            CALL    LOESCHEN 
            
            MOVLW   NACH_WIEVIEL    ;NACH 60SEC ODER 120STCK. MESSUNGEN ERFOLGT LAUFSCHRIFT
            MOVWF   ZAEHLER
;-------------------------------------------------------------------------------            
            CALL    LAUFSCHRIFT
            CALL    LOESCHEN
;------------------------------------------------------------------------------- 
 
NOCH_MAL 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;            
            
            CALL    START_I2C
            
                        MOVLW   D'5'
                        CALL    ZS1MUESEC
                        
            MOVLW   LM75_ADRESSE    ;I2C ADRESSE FUER LM75A
            CALL    TX_I2C_ACK_VOM_SLAVE
            
                        MOVLW   D'5'
                        CALL    ZS1MUESEC
                        
            MOVLW   0X00            ;I2C NORMAL MODUS FUER LM75A ALSO TEMPERATUR LESEN
            CALL    TX_I2C_ACK_VOM_SLAVE
            
                        MOVLW   D'5'
                        CALL    ZS1MUESEC
            
            CALL    STOP_I2C
            
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;            

            MOVLW   D'1'           ;10MSEC ZEITSCHLEIFE 
            CALL    ZS1MSEC
            
            CALL    START_I2C
            
                        MOVLW   D'5'
                        CALL    ZS1MUESEC
                        
            MOVLW   LM75_ADRESSE    ;I2C ADRESSE FUER LM75A 
            ADDLW   D'1'            ;FUER LESEN
            CALL    TX_I2C_ACK_VOM_SLAVE
            
                        MOVLW   D'5'
                        CALL    ZS1MUESEC
            
            CALL    RX_I2C_ACK_VOM_MASTER
            MOVWF   TEMP_H
            
                        MOVLW   D'5'
                        CALL    ZS1MUESEC
                        
            CALL    RX_I2C_NO_ACK              
            MOVWF   TEMP_L
            
                        MOVLW   D'5'
                        CALL    ZS1MUESEC
            
            CALL    STOP_I2C
            
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;      
       
            BCF     STATUS, C           ;1X
            RRF     TEMP_H, F
            RRF     TEMP_L, F
            
            BCF     STATUS, C           ;2X
            RRF     TEMP_H, F
            RRF     TEMP_L, F
            
            BCF     STATUS, C           ;3X
            RRF     TEMP_H, F
            RRF     TEMP_L, F
            
            BCF     STATUS, C           ;4X
            RRF     TEMP_H, F
            RRF     TEMP_L, F
            
            BCF     STATUS, C           ;5X
            RRF     TEMP_H, F
            RRF     TEMP_L, F

            BCF     STATUS, C           ;6X
            RRF     TEMP_H, F
            RRF     TEMP_L, F
            
            BCF     STATUS, C           ;7X
            RRF     TEMP_H, F
            RRF     TEMP_L, F

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
            CALL    TEMPERATUR_ANZEIGE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;            
         
            MOVLW   BLITZ
            MOVWF   BL
            
            BTFSS   BL, BIT0
            GOTO    BLITZ_NO
            MOVLW   0X80        ;ADRESSE
            CALL    BEFEHL
            MOVLW   "."         ;ANZEIGEN
            CALL    DATEN
            
BLITZ_NO            
;ZEITSCHLEIFE 0,1SEC
            MOVLW   D'1'
            CALL    ZS100MSEC
             
            MOVLW   0X80        ;ADRESSE
            CALL    BEFEHL
            MOVLW   " "         ;ANZEIGEN 
            CALL    DATEN 
            
;ZEITSCHLEIFE 0,9SEC
            MOVLW   D'4'
            CALL    ZS100MSEC
            
            CALL    LOESCHEN
            
            MOVLW   NACH_WIEVIEL
            SUBLW   D'0'
            BTFSC   STATUS, Z
            GOTO    NOCH_MAL
            
            DECFSZ  ZAEHLER, F
            GOTO    NOCH_MAL
            
            CALL    LAUFSCHRIFT
            MOVLW   NACH_WIEVIEL    ;NACH 60SEC ODER 120STCK. MESSUNGEN ERFOLGT LAUFSCHRIFT
            MOVWF   ZAEHLER
            
            GOTO    NOCH_MAL
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;---------------------- UNTERPROGRAMME I2C -------------------------------------
            
            
;*****************************************************************************
;*                            I2C EMPFANGEN UND KEIN ACK SENDEN              *
;*                                ERGEBNIS IN W                              *                        
;*****************************************************************************
RX_I2C_NO_ACK
                        MOVLB   D'4'             ; BANK4
                        BSF     SSP1CON2, RCEN   ; DATEN EMPFANG EINSCHALTEN
                        
RX01_NO                 BTFSS   SSP1STAT, BF     ; DATEN EMPFANG FERTIG? PUFFER VOLL
                        GOTO    RX01_NO          ; NEIN, NOCH NICHT
                        BCF     SSP1STAT, BF     ; JA, NUN NOCH BF ZURCKSETZEN
                        
                        MOVF    SSP1BUF, W       ; EMPFANGENE DATEN -> W
                        
;FALLS EIN WEITERES BYTE GELESEN WERDEN SOLL, IST ZUVOR DAS ACK-SIGNAL ZU SENDEN. 
;DAFR SETZTE MAN NUN EINFACH DAS BIT ACKEN IM REGISTER SSP1CON2.
                        BSF     SSP1CON2, ACKDT  ;ACK AUSSENDEN ALS HIGH // NUR 9-TER IMPLUS MIT SCL
                        BSF     SSP1CON2, ACKEN  ;ACK ENABLE 

                        GOTO    SPEICH_SPAR
                        
;                        MOVLB   D'0'             ; BANK0
;                        BCF     PIR1, SSP1IF     ;SSPIF ZURCKSETZEN
                        
;RX02_NO                 BTFSS   PIR1, SSP1IF     ; ACK SENDEN FERTIG?
;                        GOTO    RX02_NO          ; NEIN, NOCH NICHT
;                        BCF     PIR1, SSP1IF     ; JA, NUN NOCH SSPIF ZURCKSETZEN  
                       
;                        RETURN
                        
;*****************************************************************************
;*                            I2C EMPFANGEN UND ACK SENDEN                   *
;*                                ERGEBNIS IN W                              *                        
;*****************************************************************************
RX_I2C_ACK_VOM_MASTER
                        MOVLB   D'4'             ; BANK4
                        BSF     SSP1CON2, RCEN   ; DATEN EMPFANG EINSCHALTEN
                        
RX01                    BTFSS   SSP1STAT, BF     ; DATEN EMPFANG FERTIG? PUFFER VOLL
                        GOTO    RX01            ; NEIN, NOCH NICHT
                        BCF     SSP1STAT, BF     ; JA, NUN NOCH BF ZURCKSETZEN
                        
                        MOVF    SSP1BUF, W       ; EMPFANGENE DATEN -> W
                        
;FALLS EIN WEITERES BYTE GELESEN WERDEN SOLL, IST ZUVOR DAS ACK-SIGNAL ZU SENDEN. 
;DAFR SETZTE MAN NUN EINFACH DAS BIT ACKEN IM REGISTER SSP1CON2.
                        BCF     SSP1CON2, ACKDT  ;ACK AUSSENDEN // NUR 9-TER IMPLUS MIT SCL
                        BSF     SSP1CON2, ACKEN   

                        GOTO    SPEICH_SPAR
                        
;                        MOVLB   D'0'             ; BANK0
;                        BCF     PIR1, SSP1IF     ;SSPIF ZURCKSETZEN
                        
;RX02                    BTFSS   PIR1, SSP1IF     ; ACK SENDEN FERTIG?
;                        GOTO    RX02             ; NEIN, NOCH NICHT
;                        BCF     PIR1, SSP1IF     ; JA, NUN NOCH SSPIF ZURCKSETZEN  
                       
;                        RETURN
          
;*****************************************************************************
;*                            I2C SENDEN UND ACK VOM SLAVE EMPFANGEN         *
;*                                ZU SENDENDES BYTE IN W                     *                        
;*****************************************************************************
TX_I2C_ACK_VOM_SLAVE
                        MOVLB   D'4'             ; BANK4
                        MOVWF   SSP1BUF          ; -> ZUM I2C-SLAVE UEBERTRAGEN
                        
                        MOVLB   D'0'             ; BANK0
TX01                    BTFSS   PIR1, SSP1IF     ; DATEN UEBERTRAGEN ?
                        GOTO    TX01             ; NEIN, NOCH NICHT
                        BCF     PIR1, SSP1IF     ; JA, DATEN SIND IM SLAVE, NUN NOCH SSPIF ZURCKSETZEN
                        
;ACK EMPFANGEN
                        MOVLB   D'4'             ; BANK4                                                
                        BSF     SSP1CON2, ACKSTAT
                        
TX02                    BTFSC   SSP1CON2, ACKSTAT   ;ACK WURDE VOM SLAVE EMPFANGEN                          
                        GOTO    TX02
                        
                        MOVLB   D'0'             ; BANK0
                                                
                        RETURN 
                        

;*****************************************************************************
;*                             I2C START-BIT                                 *
;*****************************************************************************
START_I2C
;ALS EINGAENGE                        
                        MOVLB   D'1'             ; BANK1
                        BSF     TRISA, SDA
                        BSF     TRISA, SCL
                        
                        ;IN UNTERPROGRAMM
                        MOVLB   D'4'     
                        MOVLW   B'00001000'            ;BIT5=0 I2C-PORTS DISABLE // BIT4=0 I2C SCL (CLOCK) DISABLE  // BIT0-3 = 1000 MASTERMODE I2C
                        MOVWF   SSP1CON1         ; BANK4
                        BSF     SSP1CON1, SSPEN  ; ENABLE I2C-SCHNITTSTELLE
                        
                        MOVLB   D'0'             ; BANK0
                        BCF     PIR1, SSP1IF     ; SSP1IF BIT LSCHEN
                        
                        MOVLB   D'4'             ; BANK4
                        BSF     SSP1CON2, SEN    ; BUS BERNAHME ANWEISEN
                        
SPEICH_SPAR             MOVLB   D'0'             ; BANK0
                        BCF     PIR1, SSP1IF
STA01                   BTFSS   PIR1, SSP1IF     ; FERTIG ?
                        GOTO    STA01
                        
                        BCF     PIR1, SSP1IF

                        RETURN
                              
;*****************************************************************************
;*                             I2C STOP-BIT                                  *
;*****************************************************************************    
STOP_I2C
                        MOVLB   D'0'             ; BANK0
                        BCF     PIR1, SSP1IF     ; SSP1IF BIT LSCHEN    
                        MOVLB   D'4'             ; BANK4
                        BSF     SSP1CON2, PEN    ; BUS FREIGABE ANWEISEN
                        MOVLB   D'0'             ; BANK0
ST02
                        BTFSS   PIR1, SSP1IF     ; BUS SCHON FREIGEGEBEN?
                        GOTO    ST02             ; NEIN, NOCH NICHT
                        
                        BCF     PIR1, SSP1IF     ; JA, ALLES FERTIG, NUN NOCH SSP1IF ZURCKSETZEN
                        
;ALS EINGAENGE NUR ZUR SICHERHEIT                     
                        MOVLB   D'1'        ;BANK1
                        BSF     TRISA, SDA
                        BSF     TRISA, SCL
                        
                        MOVLB   D'4'        ;BANK4            
                        BCF     SSP1CON1, SSPEN ; DISABLE I2C-SCHNITTSTELLE
                        MOVLB   D'0'             ;BANK0
                        
                        RETURN

   
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;---------------------- UNTERPROGRAMME SPI -------------------------------------
                        
;*****************************************************************************
;*                             SPI EIN                                       *
;*****************************************************************************
EIN_SPI
;                        ;ALS AUSGANG  // SCHON IN INITALISIERUNG OBEN
                        MOVLB   D'1'        ;BANK1
                        BCF     TRISA, SDO
                        BCF     TRISA, SCK
                        
                        MOVLB   D'4'                ;BANK4   
                                                        
                        ;IN UNTERPROGRAMM                                
                        MOVLW   B'00010010'            
                                                       ;BIT5=0 SPI-PORTS DISABLE // BIT4=1 FUER HIGH LEVEL MODE-1,1 // AUSGABEFREQUENZ BIT0-3 = 0000 FOSC:4 MAXIMALE AUSGEBE-FREQUENZ GING BEIM DISPLAY NICHT
                                                       ;JETZT KEINE MAX AUSGABE-FREQUENZ FOSZ:64 ALS 0010 -->NUR ZUR SICHERHEIT DIE KLEINSTE AUSGABE-FREQUENZ
                        MOVWF   SSP1CON1 
                        
                        
                        
                        BSF    SSP1CON1, SSPEN      ;BIT5=1 SPI-PORTS ENABLE
                        MOVLB   D'0'                ;BANK0
                        RETURN
               
;*****************************************************************************
;*                             SPI AUS                                       *
;*****************************************************************************
AUS_SPI               
                        MOVLB   D'4'                ;BANK4               
                        BCF    SSP1CON1, SSPEN      ;BIT5=1 SPI-PORTS DISABLE
                        
;ALS EINGANG  
                        MOVLB   D'1'        ;BANK1
                        BSF     TRISA, SDO
                        BSF     TRISA, SCK
                        
                        MOVLB   D'0'                ;BANK0               
                        RETURN


;*****************************************************************************
;*              UNTERPROG. DATEN AUSGEBEN AUF DOGM-LCD-DISPLAY               *
;*****************************************************************************
DATEN       MOVWF   DAT
            BSF     PORTA, RS               ;ALS DATEN
            CALL    SPI
            RETURN
 
;*****************************************************************************
;*              UNTERPROG. DATEN AUSGEBEN AUF DOGM-LCD-DISPLAY               *
;*****************************************************************************
BEFEHL      MOVWF   DAT
            BCF     PORTA, RS               ;ALS BEFEHL
            CALL    SPI
            RETURN
                       
;*****************************************************************************
;*              UNTERPROG. AUF DOGM-LCD-DISPLAY AUSGEBEN                     *
;*****************************************************************************            
SPI
                        CALL    EIN_SPI
                        MOVLW   D'10'
                        CALL    ZS1MUESEC       ;MUSS SEIN LCD-MODUL TRAEGE RS PIN REAGIERT NICHT SOFORT
                                                ;DESHALB ZEITSCHLEIFE            

                        BCF     PORTA, CS       ;CS AKTIV
                        
                        BCF     PIR1, SSP1IF    ;MUSS SEIN !

                        MOVF    DAT, W
                        MOVLB   D'4'            ;BANK4
                        MOVWF   SSP1BUF
                        MOVLB   D'0'            ;BANK0
                        
WARTE01                 BTFSS   PIR1, SSP1IF
                        GOTO    WARTE01
                        
                        BSF     PORTA, CS       ;CS NICHT AKTIV                         

                        CALL    AUS_SPI
                        MOVLW   D'10'           ;10SEC
                        CALL    ZS1MUESEC
                        RETURN
 
;*****************************************************************************
;*                             DOT-LCD-MODUL TEXT LOESCHEN                   *
;*****************************************************************************
LOESCHEN
            MOVLW   H'01'
            CALL    BEFEHL
            
            MOVLW   D'5'
            CALL    ZS1MSEC
            RETURN 

;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;---------------------- UNTERPROGRAMME ZEITSCHLEIFEN ---------------------------
            
;*****************************************************************************
;*                            ZEITSCHLEIFE  CA. X-MAL 1SEC                  *
;*****************************************************************************
ZS1MUESEC   MOVWF   HELP1
ZZS01       NOP         ;EIN NOP = 0.03125SEC *4 = 0.125SEC  (1SEC : 0.125SEC = 8 STCK. NOPS)
            NOP
            NOP
            NOP
            NOP
    
            ;NOP
            ;NOP        ;WEGGEMACHT WEGEN ZEIT VON DECFSZ UND GOTO
            ;NOP
 
            DECFSZ  HELP1, F
            GOTO    ZZS01
            RETURN    

;MIT 8XNOP(T=4) GESAMT(T=32) 32*0,03125SEC=1SEC
    
;*****************************************************************************
;*                            ZEITSCHLEIFE TIMER0 X-MAL 1MSEC                *
;*****************************************************************************                   
ZS1MSEC                 MOVWF   HELP1

Z01                     MOVLW   D'225'
                        MOVWF   TMR0                    
                        BCF     INTCON, TMR0IF          ;OVERFLOW = 0
                 
Z02                     BTFSS   INTCON, TMR0IF            
                        GOTO    Z02                    
                      
                        DECFSZ  HELP1, F
                        GOTO    Z01
                        
                        RETURN

;ZEITBERECHNUNG FUER 1MSEC
;PRESCALER 256X  +  SYSTEM 4X  ====> 256*4*0.03125SEC=32SEC
;1MSEC:32SEC=31,25 GENOMMEN 31    
;TMR0 ALSO D'256'-D'31'=D'225' ENTSPRICHT CA. 1MSEC
;225 DEZIMAL OBEN EINTRAGEN
                            
    
;*****************************************************************************
;*                            ZEITSCHLEIFE TIMER0 X-MAL 10MSEC               *
;*****************************************************************************                   
ZS10MSEC               MOVWF   HELP2
                        
ZZ01                   MOVLW   D'10'
                       CALL    ZS1MSEC
    
                       DECFSZ   HELP2, F
                       GOTO     ZZ01
    
                       RETURN
    
;*****************************************************************************
;*                            ZEITSCHLEIFE TIMER0 X-MAL 100MSEC              *
;*****************************************************************************                   
ZS100MSEC              MOVWF   HELP3
                        
ZZZ01                  MOVLW   D'10'
                       CALL    ZS10MSEC
    
                       DECFSZ   HELP3, F
                       GOTO     ZZZ01
    
                       RETURN
        

;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;---------------------- UNTERPROGRAMME -----------------------------------------
 
;*****************************************************************************
;*                        UNTERPROGRAMM BCD-UMRECHNUNG UND ANZEIGE           *
;*                              31.03.11                                     *
;*****************************************************************************
TEMPERATUR_ANZEIGE 
            CLRF    MERK2

            MOVF    TEMP_L, W
            MOVWF   TEM

            BCF     STATUS, C
            RRF     TEM, F

W11W        BTFSS   STATUS, C
            GOTO    WW000
            MOVLW   LCD_ADR_GRAD ;H'85'                   ;ADRESSE 5
            ADDLW   D'5'
            CALL    BEFEHL
            MOVLW   H'35'                   ;0.5C DIE 5
            CALL    DATEN
            GOTO    W00W
            
WW000       MOVLW   LCD_ADR_GRAD ;H'85'                   ;ADRESSE 5
            ADDLW   D'5'
            CALL    BEFEHL
            MOVLW   H'30'                   ;0.0C DIE 0
            CALL    DATEN
            BSF     MERK2, BIT0

W00W        BTFSS   TEMP_H, BIT0            ;MUSS BIT0 SEIN /// HOEHER WERTIGE MIT NULL GEFUELLT DURCH RECHTS SCHIEBEN
            GOTO    WMW                    
            MOVF    TEMP_L, W
            MOVWF   TEM
            BSF     STATUS, C
            RRF     TEM, F

            COMF    TEM, F
            BTFSS   MERK2, BIT0
            GOTO    WMW
            INCF    TEM, F

WMW         CLRF    ANZ_L
            CLRF    ANZ_H

            BTFSS   TEM, BIT0
            GOTO    W001
            MOVLW   0X01
            MOVWF   ANZ_L

W001        BTFSS   TEM, BIT1
            GOTO    W002
            MOVF    ANZ_L, W
            ADDLW   0X02
            MOVWF   ANZ_L

W002        BTFSS   TEM, BIT2
            GOTO    W003
            MOVF    ANZ_L, W
            ADDLW   0X04
            MOVWF   ANZ_L

;-------

W003        BTFSS   TEM, BIT3
            GOTO    W004
            MOVLW   D'8'
            MOVWF   ZAE

W003B       INCF    ANZ_L, F
            MOVF    ANZ_L, W
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W003A
            MOVF    ANZ_L, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   ANZ_L

W003A       DECFSZ  ZAE, F
            GOTO    W003B

;--------

W004        BTFSS   TEM, BIT4
            GOTO    W005
            MOVLW   D'16'
            MOVWF   ZAE

W004B       INCF    ANZ_L, F
            MOVF    ANZ_L, W
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W004A
            MOVF    ANZ_L, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   ANZ_L

W004A       DECFSZ  ZAE, F
            GOTO    W004B

;--------

W005        BTFSS   TEM, BIT5
            GOTO    W006
            MOVLW   D'32'
            MOVWF   ZAE

W005B       INCF    ANZ_L, F
            MOVF    ANZ_L, W
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W005A
            MOVF    ANZ_L, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   ANZ_L 

W005A       DECFSZ  ZAE, F
            GOTO    W005B

;--------

W006        BTFSS   TEM, BIT6
            GOTO    W007
            MOVLW   D'64'
            MOVWF   ZAE

W006B       INCF    ANZ_L, F
            MOVF    ANZ_L, W
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W006A
            MOVF    ANZ_L, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   ANZ_L

            MOVF    ANZ_L, W
            ANDLW   0XFF
            MOVWF   VER 
            MOVLW   0XA0
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W006A
            CLRF    ANZ_L
            MOVF    ANZ_H, W
            ANDLW   0X0F
            ADDLW   0X01
            MOVWF   ANZ_H

W006A       DECFSZ  ZAE, F
            GOTO    W006B

;--------

W007        BTFSS   TEM, BIT7
            GOTO    W008
            MOVLW   D'128'
            MOVWF   ZAE

W007B       INCF    ANZ_L, F
            MOVF    ANZ_L, W
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            MOVF    ANZ_L, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   ANZ_L

            MOVF    ANZ_L, W
            ANDLW   0XFF
            MOVWF   VER
            MOVLW   0XA0
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W007A
            CLRF    ANZ_L
            MOVF    ANZ_H, W
            ANDLW   0X0F
            ADDLW   0X01
            MOVWF   ANZ_H

W007A       DECFSZ  ZAE, F
            GOTO    W007B


;------------
;BCD-ANZEIGE

W008        CLRF    MERK2                    ;
            CLRF    MINUS        
            BTFSS   TEMP_H, BIT0            ;MUSS BIT0 SEIN /// HOEHER WERTIGE MIT NULL GEFUELLT DURCH RECHTS SCHIEBEN
            GOTO    W111        
            BSF     MINUS, BIT0     

W111        MOVLW   LCD_ADR_GRAD ;H'81'                   ;ADRESSE 1                  
            ADDLW   D'1'
            CALL    BEFEHL
            MOVF    ANZ_H, W
            ANDLW   H'0F'
            ADDLW   H'30'
            MOVWF   VER
            MOVLW   0X30
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W009

            BSF     MINUS, BIT1
            MOVLW   0X20                    ;VORNULL AUSBLENDEN
            CALL    DATEN
            CLRF    VER
            BSF     VER, BIT7               ;MERKER FR NCHSTE NULL AUSBLENDEN
            GOTO    W010
            
W009        BSF     MERK2, BIT0              ;
            MOVF    VER, W
            CALL    DATEN


W010        MOVLW   LCD_ADR_GRAD ;  H'83'                   ;ADRESSE 3
            ADDLW   D'3'
            CALL    BEFEHL
            MOVF    ANZ_L, W
            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

            MOVLW   LCD_ADR_GRAD ; H'82'                   ;ADRESSE 2
            ADDLW   D'2'
            CALL    BEFEHL
            SWAPF   ANZ_L, W
            ANDLW   H'0F'
            ADDLW   H'30'
            MOVWF   VER
            MOVLW   0X30
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W011
            BTFSC   MERK2, BIT0              ;
            GOTO    W011                    ;
            BSF     MINUS, BIT2
            BCF     MINUS, BIT1
            MOVLW   0X20                    ;VORNULL AUSBLENDEN
            CALL    DATEN
            GOTO    W112
            
W011        MOVF    VER, W
            CALL    DATEN

W112        BTFSS   MINUS, BIT0
            GOTO    W113
            BTFSS   MINUS, BIT2
            GOTO    W114
            MOVLW   LCD_ADR_GRAD ;  H'82'                   ;ADRESSE 2
            ADDLW   D'2'
            CALL    BEFEHL
            MOVLW   H'2D'   ;MINUS -
            CALL    DATEN

W114        BTFSS   MINUS, BIT1
            GOTO    W113
            MOVLW   LCD_ADR_GRAD ;  H'81'                   ;ADRESSE 1                  
            ADDLW   D'1'
            CALL    BEFEHL
            MOVLW   H'2D'   ;MINUS -
            CALL    DATEN           


W113        MOVLW   LCD_ADR_GRAD ;0X84        ;ADRESSE
            ADDLW   D'4'
            CALL    BEFEHL
            MOVLW   "."         ;ANZEIGEN
            CALL    DATEN    
   
            MOVLW   LCD_ADR_GRAD ;0X87        ;ADRESSE
            ADDLW   D'7'
            CALL    BEFEHL
            MOVLW   "C"         ;ANZEIGEN
            CALL    DATEN    
 
            MOVLW   LCD_ADR_GRAD ;0X86        ;ADRESSE
            ADDLW   D'6'
            CALL    BEFEHL
            MOVLW   0XDF        ;ANZEIGEN 
            CALL    DATEN 
            
            RETURN 

;*****************************************************************************
;*                   UNTERPROGRAMM  LAUFSCHRIFT                              *
;*****************************************************************************
LAUFSCHRIFT         
                    MOVLW   DURCHLAEUFE         ;DURCHLAEUFE+1   SIEHE UNTERHALB
                    ADDLW   D'1'
                    MOVWF   MERK_L
                    
ANFANGL             CALL   LOESCHEN
                    DECFSZ  MERK_L, F
                    GOTO    LAUF
                    RETURN
                    
LAUF                CLRF    ZAE_L               ;ZAE_L ZAEHLER MIT BEGINN NULL LADEN...
                    CLRF    NR_HELP             ;FUER TABELLEN ZAEHLER
                    CLRF    ZEILE
                    CLRF    NEU 
                    MOVLW   D'1'
                    MOVWF   NR                  ;ZAEHLER FUER SCHNELLES BESCHREIBEN
                    
NEUES_ZEICHEN       CALL    SCHRIFT
                    MOVWF   TXT
                    MOVLW   H'00'               ;ADRESSE SPEICHERN NEUES PCLATH AM ANFANG /// *.LST FILE ADRESSE KONTROLLIEREN !!!!
                    MOVWF   PCLATH

                    MOVLW   0XFF                ;TXT-ENDE-ERKENNUNG
                    SUBWF   TXT, W              ;HIER WAR DIE ZEILE SCHON LANGSAM MIT GESCHWINDIGKEIT GEFUELLT WORDEN
                    BTFSC   STATUS, Z           ;ES BEGINNT VON VORNE MIT EINEM ZEICHEN WEGLASSEN AUS TABELLE /// ALSO NR_HELP MIT NEU   --- SIEHE UNTEN AM SCHLUSS
                    GOTO    LEER_FUELL ;ANFANGL             ;SCHLUSS / ES HAT DAS 0XFF ERKANNT ALS ENDEKENNZEICHEN IN DER TABELLE

;AUF LCD ANZEIGEN
                    MOVF    NR, W               ;NR ZAEHLER FUER SCHNELLES BESCHREIBEN /// WIE VIELE ZEICHEN IST NR
                    SUBLW   L_ADRESSE           ;H'8F' ;H'87' ===> L_ADRESSE - NR = LCD_ADR
                    MOVWF   LCD_ADR

WEITER3             INCF    LCD_ADR, F          ;SCHNELLES BESCHREIBEN
                    INCF    ZAE_L, F

                    MOVF    LCD_ADR, W          ;NEUES HINZUGEKOMMENES ZEICHEN
                    CALL    BEFEHL
                    MOVF    TXT, W
                    CALL    DATEN
                    
;ENDE ERKENNUNG FUER ZEILE BESCHREIBEN
                    MOVF    ZAE_L, W
                    SUBLW   ANZAHL              ;D'16' ;D'8' 
                    BTFSC   STATUS, Z
                    GOTO    VOLL                ;ZEILE VOLL SCHNELL

                    MOVF    ZAE_L, W            ;DIE ERSTEN ZEICHEN, WELCHE ES REINSCHIEBT BIS VOLL DANN GILT OBEN
                    SUBWF   NR, W               ;NR ZU ERST NULL /// DANN UNTEN ERHOEHT
                    BTFSC   STATUS, Z
                    GOTO    ZEITSCHLEIFE 

;NEUES ZEICHEN AUF ZEILE
WEITER4             INCF    NR_HELP, F
                    CALL    SCHRIFT
                    MOVWF   TXT
                    MOVLW   H'00'               ;ADRESSE SPEICHERN NEUES PCLATH AM ANFANG /// *.LST FILE ADRESSE KONTROLLIEREN !!!!
                    MOVWF   PCLATH

                    MOVLW   0XFF                ;TXT-ENDE-ERKENNUNG
                    SUBWF   TXT, W
                    BTFSC   STATUS, Z           ;ZEILE WURDE SCHNELL GEFUELLT IST ABER NICHT GANZ VOLL BEI ANFANGL
                    GOTO    LEER_FUELL ;ANFANGL             ;SCHLUSS / ES HAT DAS 0XFF ERKANNT ALS ENDEKENNZEICHEN IN DER TABELLE
                    GOTO    WEITER3

VOLL                BSF     ZEILE, BIT0

ZEITSCHLEIFE        MOVLW   GESCHWINDIGKEIT
                    CALL    ZS10MSEC
            
                    BTFSC   ZEILE, BIT0
                    GOTO    VOLLA

                    INCF    NR, F               ;NACH EINANDER SCHNELL FUELLEN // EINE ZEILE
                    CLRF    NR_HELP             ;AUCH BEI NICHT GANZ VOLLER ZEILE
                    
                    CLRF    ZAE_L
                    GOTO    NEUES_ZEICHEN

                    
                    
VOLLA               MOVLW   ANZAHL              ;D'16' ;D'8'
                    MOVWF   NR
                                          
                    INCF    NEU, F              ;ES VERSCHWINDET IMMER EIN ZEICHEN VON DER TABELLE
                    MOVF    NEU, W              ;VORHER IST ALLES MIT ZEICHEN GEFUELLT GEWESEN
                    MOVWF   NR_HELP

                    CLRF    ZAE_L
                    GOTO    NEUES_ZEICHEN       ;ACHTUNG HIER FUER 2-TE ZEILE VOM DISPLAY STARTEN   ODER 1X16 DISPLAY 
                                                ;MUSS MEHR WIE 8/16 ZEICHEN SEIN !!!!!!!!!!!!!!!!

;-------------------------------------------------------------------------------                    
                    
LEER_FUELL          
;ENDE ERKENNUNG FUER ZEILE BESCHREIBEN
                    MOVF    LCD_ADR, W
                    ANDLW   0X0F
                    SUBLW   0X00                ;0X80 0XC0 PRUEFEN
                    BTFSC   STATUS, Z
                    GOTO    ANFANGL             ;START DURCHLAEUFE MACHEN
                    
                    INCF    LCD_ADR, F          ;SCHNELLES BESCHREIBEN
                    INCF    ZAE_L, F
                    
                    MOVF    LCD_ADR, W          ;NEUES HINZUGEKOMMENES ZEICHEN
                    CALL    BEFEHL
                    MOVLW   " "                 ;LEERZEICHEN
                    CALL    DATEN
                    
                    MOVF    ZAE_L, W
                    SUBLW   ANZAHL              ;D'16' ;D'8' 
                    BTFSS   STATUS, Z
                    GOTO    LEER_FUELL
                    GOTO    ZEITSCHLEIFE        ;LANGSAM LETZTES ZEICHEN 

            

    ORG 0X0300
;*****************************************************************************
;*                              UNTERPROGRAMM                                *
;*****************************************************************************
SCHRIFT
    MOVLW   H'03'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
    MOVWF   PCLATH

    MOVF    NR_HELP, W  ; SPRUNGDISTANZ
    ADDWF   PCL,F       ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  

    
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------
        
;JETZT KOMMT DER TEXT
;ES KOENNEN CA. 240 ZEILEN MIT RETLW EINGETRAGEN WERDEN /// ALSO BIS SPEICHERENDE 0X3FF /// KONTROLLIERE LIST-FILE

    RETLW "T"
    RETLW 0X65 ;E  //GEHT AUCH SO "E" ODER H'65'
    RETLW 0X6D ;M 
    RETLW 0X70 ;P
    RETLW 0X65 ;E
    RETLW 0X72 ;R
    RETLW 0X61 ;A
    RETLW 0X74 ;T
    RETLW 0X75 ;U
    RETLW 0X72 ;R
    RETLW "-"
    RETLW "M"
    RETLW 0X65 ;E
    RETLW 0X73 ;S
    RETLW 0X73 ;S
    RETLW 0X75 ;U
    RETLW 0X6E ;N
    RETLW 0X67 ;G
    
    RETLW " "           ;    ES WIRD AUTOMATISCH MIT LAUFSCHRIFT LEERZEICHEN AUFGEFUELLT /// BIS ALLES LEERZEICHEN
    RETLW " "           ; -- EINE ZEILE IST VOLL
    RETLW 0XFF          ;ENDEKENNUNG MUSS DRIN BLEIBEN                    
                    
                    
                    
                       
                       END
    
    
    